GpgFrontend::GlobalSettingStation Class Reference
Inheritance diagram for GpgFrontend::GlobalSettingStation:
Collaboration diagram for GpgFrontend::GlobalSettingStation:

## Public Member Functions

| GlobalSettingStation (int channel=SingletonFunctionObject::GetDefaultChannel()) noexcept
| Construct a new Global Setting Station object. More...
| ~GlobalSettingStation () noexcept override
| Destroy the Global Setting Station object. More...
libconfig::Setting & | GetUISettings () noexcept
std::filesystem::path | GetAppDir () const
| Get the App Dir object. More...
std::filesystem::path | GetAppDataPath () const
std::filesystem::path | GetLogDir () const
| Get the Log Dir object. More...
std::filesystem::path | GetStandaloneDatabaseDir () const
| Get the Standalone Database Dir object. More...
std::filesystem::path | GetAppConfigPath () const
std::filesystem::path | GetStandaloneGpgBinDir () const
| Get the Standalone Gpg Bin Dir object. More...
std::filesystem::path | GetLocaleDir () const
| Get the Locale Dir object. More...
std::filesystem::path | GetResourceDir () const
| Get the Resource Dir object. More...
std::filesystem::path | GetCertsDir () const
| Get the Certs Dir object. More...
void | SyncSettings () noexcept
| sync the settings to the file More...
Public Member Functions inherited from GpgFrontend::SingletonFunctionObject< GlobalSettingStation >
| SingletonFunctionObject (const SingletonFunctionObject< GlobalSettingStation > &)=delete
| prohibit copy More...
| SingletonFunctionObject (GlobalSettingStation &&)=delete
| Construct a new Singleton Function Object object. More...
| SingletonFunctionObject (const GlobalSettingStation &)=delete
| Construct a new Singleton Function Object object. More...
SingletonFunctionObject & | operator= (const SingletonFunctionObject< GlobalSettingStation > &)=delete
| prohibit copy More...
void | operator= (const GlobalSettingStation &)=delete
int | GetChannel () const
| Get the Channel object. More...
Public Member Functions inherited from GpgFrontend::ChannelObject
| ChannelObject () noexcept
| Construct a new Default Channel Object object. More...
| ChannelObject (int channel)
| Construct a new Channel Object object. More...
int | GetChannel () const
| Get the Channel object. More...
void | SetChannel (int channel)
| Set the Channel object. More...

## Private Member Functions

void | init_app_secure_key ()

## Private Attributes

std::filesystem::path | app_path_
| Program Location. More...
std::filesystem::path | app_data_path_
| Program Data Location. More...
std::filesystem::path | app_log_path_
| Program Data Location. More...
std::filesystem::path | app_data_objs_path_
| Object storage path. More...
std::filesystem::path | app_resource_path_
| Program Data Location. More...
std::filesystem::path | app_locale_path_
| Program Data Location. More...
std::filesystem::path | app_configure_path_
| Program Configure Location. More...
std::filesystem::path | ui_config_dir_path_
| Configure File Directory Location. More...
std::filesystem::path | ui_config_path_
| UI Configure File Location. More...
libconfig::Config | ui_cfg_
| UI Configure File.

## Additional Inherited Members

Static Public Member Functions inherited from GpgFrontend::SingletonFunctionObject< GlobalSettingStation >
static GlobalSettingStation & | GetInstance (int channel=GpgFrontend::GPGFRONTEND_DEFAULT_CHANNEL)
| Get the Instance object. More...
static GlobalSettingStation & | CreateInstance (int channel, std::function< std::unique_ptr< ChannelObject >(void)> factory)
| Create a Instance object. More...
static void | ReleaseChannel (int channel)
static int | GetDefaultChannel ()
| Get the Default Channel object. More...
static std::vector< int > | GetAllChannelId ()
| Get all the channel ids. More...
Static Public Member Functions inherited from GpgFrontend::ChannelObject
static int | GetDefaultChannel ()
| Get the Default Channel object. More...
Protected Member Functions inherited from GpgFrontend::SingletonFunctionObject< GlobalSettingStation >
| SingletonFunctionObject ()=default
| Construct a new Singleton Function Object object. More...
| SingletonFunctionObject (int channel)
| Construct a new Singleton Function Object object. More...
virtual | ~SingletonFunctionObject ()=default
| Destroy the Singleton Function Object object. More...

## Constructor & Destructor Documentation

## GlobalSettingStation()

GpgFrontend::GlobalSettingStation::GlobalSettingStation | ( | int | channel = `SingletonFunctionObject::GetDefaultChannel()` | ) |

explicitnoexcept

Construct a new Global Setting Station object.

References app_configure_path_, app_data_path_, app_locale_path_, app_log_path_, app_path_, ui_cfg_, ui_config_dir_path_, and ui_config_path_.

## ~GlobalSettingStation()

GpgFrontend::GlobalSettingStation::~GlobalSettingStation | ( |  | ) |

overridedefaultnoexcept

Destroy the Global Setting Station object.

## Member Function Documentation

## GetAppDir()

std::filesystem::path GpgFrontend::GlobalSettingStation::GetAppDir | ( |  | ) | const

inline

Get the App Dir object.

Returns
  std::filesystem::path

## GetCertsDir()

std::filesystem::path GpgFrontend::GlobalSettingStation::GetCertsDir | ( |  | ) | const

inline

Get the Certs Dir object.

Returns
  std::filesystem::path

## GetLocaleDir()

std::filesystem::path GpgFrontend::GlobalSettingStation::GetLocaleDir | ( |  | ) | const

inline

Get the Locale Dir object.

Returns
  std::filesystem::path

Referenced by GpgFrontend::UI::init_locale(), and GpgFrontend::UI::SettingsDialog::ListLanguages().

## GetLogDir()

std::filesystem::path GpgFrontend::GlobalSettingStation::GetLogDir | ( |  | ) | const

inline

Get the Log Dir object.

Returns
  std::filesystem::path

Referenced by GpgFrontend::UI::init_logging_system(), and GpgFrontend::InitLoggingSystem().

## GetResourceDir()

std::filesystem::path GpgFrontend::GlobalSettingStation::GetResourceDir | ( |  | ) | const

inline

Get the Resource Dir object.

Returns
  std::filesystem::path

Referenced by GpgFrontend::UI::InitGpgFrontendUI(), and GpgFrontend::UI::TranslatorsTab::TranslatorsTab().

## GetStandaloneDatabaseDir()

std::filesystem::path GpgFrontend::GlobalSettingStation::GetStandaloneDatabaseDir | ( |  | ) | const

inline

Get the Standalone Database Dir object.

Returns
  std::filesystem::path

## GetStandaloneGpgBinDir()

std::filesystem::path GpgFrontend::GlobalSettingStation::GetStandaloneGpgBinDir | ( |  | ) | const

inline

Get the Standalone Gpg Bin Dir object.

Returns
  std::filesystem::path

## GetUISettings()

libconfig::Setting& GpgFrontend::GlobalSettingStation::GetUISettings | ( |  | ) |

inlinenoexcept

Returns
  libconfig::Setting&

Referenced by GpgFrontend::UI::KeyList::dropEvent(), GpgFrontend::UI::MainWindow::Init(), GpgFrontend::UI::init_locale(), GpgFrontend::UI::KeyGenDialog::KeyGenDialog(), GpgFrontend::UI::KeyMgmt::KeyMgmt(), GpgFrontend::UI::MainWindow::restore_settings(), GpgFrontend::UI::MainWindow::save_settings(), GpgFrontend::UI::NetworkTab::SetSettings(), GpgFrontend::UI::GeneralTab::SetSettings(), GpgFrontend::UI::KeyUploadDialog::slot_upload_key_to_server(), GpgFrontend::UI::MainWindow::SlotFileEncrypt(), GpgFrontend::UI::MainWindow::SlotFileEncryptSign(), GpgFrontend::UI::MainWindow::SlotFileSign(), GpgFrontend::UI::MainWindow::SlotFileVerify(), GpgFrontend::UI::CommonUtils::SlotImportKeyFromKeyServer(), GpgFrontend::UI::SubkeyGenerateDialog::SubkeyGenerateDialog(), and GpgFrontend::UI::Wizard::Wizard().

## SyncSettings()

void GpgFrontend::GlobalSettingStation::SyncSettings | ( |  | ) |

noexcept

sync the settings to the file

Copyright (C) 2021 Saturneric

This file is part of GpgFrontend.

GpgFrontend is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

GpgFrontend is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with GpgFrontend. If not, see https://www.gnu.org/licenses/.

The initial version of the source code is inherited from the gpg4usb project, which is under GPL-3.0-or-later.

All the source code of GpgFrontend was modified and released by Saturnericeric@.nosp@m.bktu.nosp@m.s.com starting on May 12, 2021.

SPDX-License-Identifier: GPL-3.0-or-later

References ui_cfg_, and ui_config_path_.

Referenced by GpgFrontend::UI::KeyList::dropEvent(), GpgFrontend::UI::init_locale(), GpgFrontend::UI::MainWindow::restore_settings(), and GpgFrontend::UI::MainWindow::save_settings().

## Member Data Documentation

## app_configure_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::app_configure_path_

private

Initial value:
=
QStandardPaths::writableLocation(QStandardPaths::AppConfigLocation)
.toStdString()

Program Configure Location.

Referenced by GlobalSettingStation().

## app_data_objs_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::app_data_objs_path_

private

Initial value:
=
app_data_path_ / "objs"

Object storage path.

## app_data_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::app_data_path_

private

Initial value:
=
QStandardPaths::writableLocation(QStandardPaths::AppLocalDataLocation)
.toStdString()

Program Data Location.

Referenced by GlobalSettingStation().

## app_locale_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::app_locale_path_

private

Initial value:
=
app_resource_path_ / "locales"

Program Data Location.

Referenced by GlobalSettingStation().

## app_log_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::app_log_path_

private

Initial value:
=
app_data_path_ / "logs"

Program Data Location.

Referenced by GlobalSettingStation().

## app_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::app_path_

private

Initial value:
= QCoreApplication::applicationDirPath()
.toStdString()

Program Location.

Referenced by GlobalSettingStation().

## app_resource_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::app_resource_path_

private

Initial value:
=
RESOURCE_DIR_BOOST_PATH(app_path_)

Program Data Location.

## ui_config_dir_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::ui_config_dir_path_

private

Initial value:
=
app_configure_path_ /
"UserInterface"

Configure File Directory Location.

Referenced by GlobalSettingStation().

## ui_config_path_

std::filesystem::path GpgFrontend::GlobalSettingStation::ui_config_path_

private

Initial value:
=
ui_config_dir_path_ / "ui.cfg"

UI Configure File Location.

Referenced by GlobalSettingStation(), and SyncSettings().

The documentation for this class was generated from the following files:

- src/core/function/GlobalSettingStation.h
- src/core/function/GlobalSettingStation.cpp

GpgFrontend::GlobalSettingStation::app_resource_path_
std::filesystem::path app_resource_path_
Program Data Location.
Definition: GlobalSettingStation.h:160
GpgFrontend::GlobalSettingStation::app_data_path_
std::filesystem::path app_data_path_
Program Data Location.
Definition: GlobalSettingStation.h:147
GpgFrontend::GlobalSettingStation::ui_config_dir_path_
std::filesystem::path ui_config_dir_path_
Configure File Directory Location.
Definition: GlobalSettingStation.h:175
GpgFrontend::GlobalSettingStation::app_path_
std::filesystem::path app_path_
Program Location.
Definition: GlobalSettingStation.h:145
GpgFrontend::GlobalSettingStation::app_configure_path_
std::filesystem::path app_configure_path_
Program Configure Location.
Definition: GlobalSettingStation.h:172